# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# Audacious subplugin for CurrentSong plugin
# by rescbr

VERSION = '0.1'

import os
import commands

import CurrentSong
 
class Audacious( CurrentSong.CurrentSong ):

    def __init__( self ):
        # init for this class
        CurrentSong.CurrentSong.__init__( self )
        self.playingNow = ''
        self.check()
     
    def isRunning( self ):
        # check if audacious is running
        if commands.getoutput( "audtool playback-status" ) != "audtool: audacious server is not running!":
            return True  #k, running
        return False #not running
        
    def isPlaying( self ):
        # check if audacious is playing anything
        if commands.getoutput( "audtool playback-status" ) == "playing":
            return True  #yeah, is playing
        return False #not playing
        
    def getStatus( self ):
        '''check if everything is OK to start the plugin
        return a tuple whith a boolean and a message
        if OK -> ( True , 'some message' )
        else -> ( False , 'error message' )'''
        
        if os.name != 'posix':
            return ( False, _( 'This plugin only works in posix systems' ) ) #no posix here
   
        if not self.is_on_path( 'audtool' ):
            return ( False, _( 'audtool not found in path.' ) ) #no audtool here
        
        return ( True, 'Ok' ) #ok, run baby!

    def getCurrentSong( self ):
        if self.isRunning() and self.isPlaying():
            song = commands.getoutput( "audtool current-song" )
            fsong = '\\0Music\\01\\0' + song + '\\0\\0'
            return fsong
        else:
            return ''
        
    def check( self ):
        if self.isRunning() and self.isPlaying() and self.playingNow != self.getCurrentSong():
            self.playingNow = self.getCurrentSong()
            return True
        return False
